let cpUtil = {
    meta : {version : '1.31' , last_mod : '2024-11-29'},
    cp_class : 'cpUtil_icon',
    popup_id : 'cpUtil_popup',
    options : {title : true, url : true , query :true }, //コピー対象にページタイトル / ページURL / URLのクエリ部分 を含めるかどうか
    text : '',      //コピーされるテキスト
    tooltip : '',   //ボタンのツールチップ
    lang : 'ja' , // lang : 'en',   // ツールチップ / ポップアップダイアログの言語

    init : function(){
        cpUtil.set_text();
        cpUtil.set_tooltip();

        const cp_icons = document.getElementsByClassName(cpUtil.cp_class);

        for(let i=0; i<cp_icons.length ; i++){
            cp_icons[i].addEventListener('click' , cpUtil.cp2clipboard , false);
            cp_icons[i].title = cpUtil.tooltip;
        }
    },

    set_tooltip : function(){
        const opt = cpUtil.options;
        if( cpUtil.lang == 'ja'){
            if( opt.title ) cpUtil.tooltip = 'タイトル';
            if( opt.url ) {
                cpUtil.tooltip += (cpUtil.tooltip.length ? 'と' : '') + 'URLをクリップボードにコピー';
            }else{
                if( cpUtil.tooltip.length ) cpUtil.tooltip +='をクリップボードにコピー';
            }
        }else{
            if( opt.title ) cpUtil.tooltip = 'title';
            if( opt.url ) {
                cpUtil.tooltip += (cpUtil.tooltip.length ? ' and ' : '') + 'URL to clipboard';
            }
            if( cpUtil.tooltip.length ) cpUtil.tooltip ='Copy ' + cpUtil.tooltip;
        }
    },

    set_text : function(){
        const opt = cpUtil.options;
        if( opt.title ) cpUtil.text = document.title;
        if( opt.url ){
            cpUtil.text += "\n " +  ( opt.query ? window.location.href : window.location.origin + window.location.pathname);
        }
    },

    set_options : function(opt){
        for( const key in opt){
            if( cpUtil.options.hasOwnProperty(key) ) cpUtil.options[key] = opt[key];
        }
    },

    set_lang : function(lang){
        cpUtil.lang = 'en';
        if(lang=='ja')cpUtil.lang = lang;
    },

    cp2clipboard : function(evt){
        if(!cpUtil.tooltip.length)return false;
        navigator.clipboard.writeText(cpUtil.text);

        const pop = document.body.appendChild(document.createElement('div'));
        pop.id = cpUtil.popup_id;
        pop.innerText = cpUtil.lang == 'ja' ? cpUtil.tooltip +'しました！' : 'Copied to clipboard!';
        pop.addEventListener('animationend',()=>{
            pop.parentElement.removeChild(pop);
        },{once:true});
    }
}

document.addEventListener('DOMContentLoaded' , cpUtil.init , false);
